import queue


n,m,k = map(int,input().split())
gr = [[] for _ in range(n+1)]
for i in range(m):
    a,b = map(int,input().split())
    gr[a].append(b)
    gr[b].append(a)

guarded = [0]*(n+1)

for i in range(k):
    point, run = map(int, input().split())
    dist = [10000]*(n+1)
    dist[point] = 0
    q = queue.Queue()
    q.put(point)
    guarded[point] = 1
    while(not q.empty()):
        now = q.get()
        if(dist[now]>run):
            break

        for wh in gr[now]:
            if(dist[wh]==10000):
                q.put(wh)
                dist[wh] = min(dist[wh], dist[now]+1)
                if(dist[wh] <= run):
                    guarded[wh] = 1


ans = []
for i in range(len(guarded)):
    if(guarded[i] ==1): ans.append(i)

print(len(ans))
print(*ans)


